/*

* EXP_GUIDIALOG.PRG

* // ( 26.05.2011 )

*  COBA Systems Software
* BAST Open Source Project
* Business Account Software Technology
* www.cobasystems.com

*/


/*

eXpress++ code

POJEDINANI DIALOZI Security, Database, Settings

Jedan GUI dialog se moe startovati bezboroj puta u bezbroj instanci.
Ovde je dat primer pisanja GUI dialoga koji se ne moe startovati
dva puta jer se proverava preko njegovog windows hendlera da li je
ve startovan.
VAI PRAVILO: NE MOE SE STARTOVATI NIJEDAN DRUGI GUI DIALOG
DOK SE PRETHODNO NE IZAE IZ VE STARTOVANOG GUI DIALOGA

Koristi se kod aplikacija koje dozvoljavaju da se istovremeno
startuje vie GUI dialoga, odnosno daju mogunost starta jednog
istog GUI dialoga vie puta (u vie instanci)

Ovde se ne mogu istovremeno startovati tri dialoga: dialog Security,
dialog Database i dialog Settings, moe se startovati jedan od njih
a tek posle njegove terminacije moe se startovati drugi od njih ili
opet taj isti.

*/

#include "common.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "font.ch"
#include "gra.ch"
#include "xbtsys.ch"

#include "dctree.ch"
#include "dcdialog.ch"


// VANO
//
// Ako je GetList1 LOCAL tada se mora poslati ovoj
// funkciji kao parametar @GetList1 da ga aurira
// Funkcija mora da primi kao parametar GetList1
// iz glavnog programa - inae ne radi sve kako treba !
//
// Zbog toga je najbolje da je GetList1 PUBLIC varijabla
// pa se ne mora slati kao parametar @GetList
// a tada najmanje problema ima i sve najbolje radi
// kada se ova funkcija nalazi u istom PRG modulu
// u kome je i GetList1.
//
// Jo je vanije i treba znati da program dcreadgui_1()
// kada je poseban exe ili dll modul radie bez problema
//
// Glavni program iz koga se pozivaju ova tri prozora
// mora da ima komandu DCREAD GUI u svemu kako je ovde data:
// DCREAD GUI TITLE GlavniTitle  ;
//        OPTIONS GetOptions     ;
//        FIT ; // ZA RAD SA VIE POSEBNIH PROZORA KOJI SE FORMIRAJU ODAVDE:
//              PARENT @oDlgGlavni     ;     // MORA DA POSTOJI KOMANDA
//              APPWINDOW @oDlgGlavni  ;     // MORA DA POSTOJI KOMANDA
//              CLEAREVENTS            ;     // MORA DA POSTOJI KOMANDA
//              MULTILISTS             ;     // MORA DA POSTOJI KOMANDA
//              MODAL                  ;     // MORA DA POSTOJI KOMANDA
//              EVAL {|o| SetAppWindow(o) }  // MORA DA POSTOJI KOMANDA
**************************************************
FUNCTION dcreadgui_1(prog,GetList1)
**************************************************
STATIC hw := 0
LOCAL GetList := {},  GetOptions, oDlg

   IF hw > 0     // VANO ZA DRUGU INSTANCU PROZORA
      tone(500)
      RETURN NIL
   ENDIF


set date german; set century on
datum := date(); naziv := PADR(prog,40)
@ 1,1 DCSAY prog SAYSIZE 0 FONT "14.Verdana Bold"

@ 4,1 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 60, 12 ;
      OPTIONS XBPSTATIC_TEXT_WORDBREAK CAPTION { || TEKST() }

@ 19,1 DCPUSHBUTTON CAPTION "Kraj" SIZE 10,1.2 ;
       ACTION {|| implode(oDlg,hw), DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

DCGETOPTIONS COLOR {220,240,150} ;
WINDOWCOL 0 WINDOWROW 0 WINDOWHEIGHT 440 WINDOWWIDTH 434 ;
BORDER XBPDLG_NO_BORDER NOTITLEBAR  //NOMINBUTTON NOMAXBUTTON TABSTOP NOTASKLIST

DCREAD GUI TITLE prog OPTIONS GetOptions ;
              PARENT @oDlg               ;        // POSTAVKA ZA PROZOR U PROZORU
              APPWINDOW @oPanel2         ;        // POSTAVKA ZA PROZOR U PROZORU
              CLEAREVENTS                ;
                        EVAL {|o| SetAppWindow(o) ,;
                        hw  := o:getHWND(),;      // ZA DRUGU INSTANCU PROZORA
                        explode(oDlg,hw) }        // ZA EXPLODE EFEKAT

hw := 0        // ZBOG STATIC hw1 - OVO MORA DA BUDE OVDE
Gkraj()        // REPAINT EKRANA - LOGO SLIKE EKRANA
RETURN NIL





**************************************************
STATIC FUNCTION explode(oDlg,hw)
**************************************************
// Za explode efekat postavi se
// WINDOWHEIGHT 400-15-10
// pa se pozove:
 * oDlg:setframestate(XBPDLG_FRAMESTAT_MAXIMIZED)
// isto moe i preko Windows API DLL funkcija
// uz upotrebu hw
RETURN NIL

**************************************************
STATIC FUNCTION implode(oDlg,hw)
**************************************************
  oDlg:setframestate(XBPDLG_FRAMESTAT_MINIMIZED)
// isto moe i preko Windows API DLL funkcija
// uz upotrebu hw
RETURN NIL

**************************************************
STATIC FUNCTION Gkraj() // OSVEAVANJE SLIKE EKRANA
**************************************************
// PUBLIC oPanel2, oTree
oPanel2:hide()
oPanel2:show()
SetAppFocus(oTree)
RETURN NIL


STATIC FUNCTION TEKST()
LOCAL ch := chr(13)+chr(10)
ctxt := ;
"eXpress++ code "+ch+;
"POJEDINANI DIALOZI Security, Database, Settings"+ch+;
" "+ch+;
"Jedan GUI dialog se moe startovati bezboroj puta u bezbroj instanci. "+;
"Ovde je dat primer pisanja GUI dialoga koji se ne moe startovati "+;
"dva puta jer se proverava preko njegovog windows hendlera da li je "+;
"ve startovan. "+ch+ch+;
"VAI PRAVILO: NE MOE SE STARTOVATI NIJEDAN DRUGI GUI DIALOG "+;
"DOK SE PRETHODNO NE IZAE IZ VE STARTOVANOG GUI DIALOGA "+;
" "+ch+ch+;
"Koristi se kod aplikacija koje dozvoljavaju da se istovremeno "+;
"startuje vie GUI dialoga, odnosno daju mogunost starta jednog "+;
"istog GUI dialoga vie puta (u vie instanci) "+ch+;
" "+ch+;
"Ovde se ne mogu istovremeno startovati tri dialoga: dialog Security, "+;
"dialog Database i dialog Settings, moe se startovati jedan od njih "+;
"a tek posle njegove terminacije moe se startovati drugi od njih ili "+;
"opet taj isti."

RETURN cTxt


STATIC FUNCTION prazno();RETURN NIL   // ne moe da postoji PRG bez funkcija
