/*

* MAIN.PRG

* // ( 26.05.2011 )

*  COBA Systems Software
* BAST Open Source Project
* Business Account Software Technology
* www.cobasystems.com

*/


* Menu Tree sistem - varijanta 2

#include "common.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "font.ch"
#include "gra.ch"
#include "xbtsys.ch"

#include "dctree.ch"
#include "dcdialog.ch"

#include "test.ch"  // test.arc, test.res



EXIT PROCEDURE LogOut()
 // APLIKACIJA ZAVRENA SA QUIT
 // MsgBox(var2char(XPRESTART),"XPRESTART")
 IF XPRESTART == .T.
    app := appname(.T.)
    q   := RunShell("",app) // RESTART APLIKACIJE
 ENDIF
RETURN

PROCEDURE AppSys()
RETURN


**************************************************
PROCEDURE Main()
**************************************************

PUBLIC GetList1 := {}, oSubTree1, oSubTree2, cSelected, ;
GlavniTitle := "TREE MENU APPLICATION | DEO 1"

PUBLIC oPanel1, oPanel2, oDlgGlavni
PUBLIC oPanel3, oG1, oG2, oTree, oKraj, XPRESTART := .F.

 SET DATE GERMAN
 SET CHARSET TO ANSI

/*
   * kada se ukljui ova kontrola starta druge instance programa, ne moe se program
   * startovati dva puta ali ne radi ni restrat programa pa se zbog toga ovde iskljuuje:
   IF WIN_START(GlavniTitle) == .F.  // __WIN_START.PRG
     confirmbox(,"Program je ve startovan","STOP",XBPMB_OK,XBPMB_CRITICAL,XBPMB_SYSMODAL)
     RETURN NIL
   ENDIF
*/

@ 1,1  DCSTATIC TYPE XBPSTATIC_TYPE_GROUPBOX OBJECT oPanel0  SIZE 85, 3 CAPTION "Knjigovodstvo"

@ 1.8,1.3 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT OBJECT oPanel3  SIZE 84, 2 ;
      OPTIONS XBPSTATIC_TEXT_CENTER FONT "14.Verdana Bold" ; // COLOR GRA_CLR_DARKRED
      CAPTION "DEO 1. PROGRAMMING IN Xbase++ and eXpress++"

@ 4,1  DCSTATIC TYPE XBPSTATIC_TYPE_GROUPBOX OBJECT oPanel1  SIZE 22, 22 CAPTION "Glavni Meni" GROUP oG1

@ 4,24 DCSTATIC TYPE XBPSTATIC_TYPE_GROUPBOX OBJECT oPanel2  SIZE 62, 22 CAPTION "Program ( GUI Dialog )"  GROUP oG2
@ 14,1  DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP PIXEL OBJECT oSlika PARENT oPanel2 SIZE 430,420 CAPTION B_LOGO GROUP oG2


//------------------------------- TREE MENU

@ 1,1 DCTREEROOT SIZE 20,20 OBJECT oTree TITLE 'Tree Root' HASLINES HASBUTTONS ALWAYSSHOWSELECTION PARENT oPanel1;
      ITEMSELECTED {|o| meni(o,oTree), SetAppFocus(oTree), DC_GetRefresh(GetList1) } GROUP oG1


  DCTREEITEM CAPTION 'PLATE' PARENT oTree OBJECT oSubTree1
  DCTREEITEM CAPTION 'Zaposleni'    PARENT oSubTree1  CARGO "11"
  DCTREEITEM CAPTION 'Porezi'       PARENT oSubTree1  CARGO "12"
  DCTREEITEM CAPTION 'Doprinosi'    PARENT oSubTree1  CARGO "13"

  DCTREEITEM CAPTION 'ZALIHE'       PARENT oTree OBJECT oSubTree2
  DCTREEITEM CAPTION 'Kalkulacije'  PARENT oSubTree2  CARGO "21"
  DCTREEITEM CAPTION 'Nivelacije'   PARENT oSubTree2  CARGO "22"
  DCTREEITEM CAPTION 'Fakture'      PARENT oSubTree2  CARGO "23"

  DCTREEITEM CAPTION 'SISTEM'       PARENT oTree OBJECT oSubTree3
  DCTREEITEM CAPTION 'Security'     PARENT oSubTree3  CARGO "31"
  DCTREEITEM CAPTION 'Database'     PARENT oSubTree3  CARGO "32"
  DCTREEITEM CAPTION 'Settings'     PARENT oSubTree3  CARGO "33"

  DCTREEITEM CAPTION 'Appearance'   PARENT oSubTree3  CARGO "34"
  DCTREEITEM CAPTION 'Restart'      PARENT oSubTree3  CARGO "35"

//------------------------------- TREE MENU


@ 27,1   DCPUSHBUTTON CAPTION "Help" SIZE 8,1.2 ACTION {|| help1() }
@ 27,1+8 DCPUSHBUTTON CAPTION "Kraj" SIZE 8,1.2 ACTION {|| Kraj(GetList1) } OBJECT oKraj

DCGETOPTIONS ICON 1 FONT "8.Verdana" NOESCAPEKEY

DCREAD GUI TITLE GlavniTitle  ;
       OPTIONS GetOptions     ;
       FIT ; // ZA RAD SA VIE POSEBNIH PROZORA KOJI SE FORMIRAJU ODAVDE:
              PARENT @oDlgGlavni     ;     // MORA DA POSTOJI KOMANDA
              APPWINDOW @oDlgGlavni  ;     // MORA DA POSTOJI KOMANDA
              CLEAREVENTS            ;     // MORA DA POSTOJI KOMANDA
              MULTILISTS             ;     // MORA DA POSTOJI KOMANDA KAD SE RADI SA VIE GetList
              MODAL                  ;     // MORA DA POSTOJI KOMANDA
              EVAL {|o| SetAppWindow(o) }  // MORA DA POSTOJI KOMANDA
RETURN

**************************************************
FUNCTION Kraj(GetList1)
**************************************************
// implode efekat
oDlgGlavni:setframestate(XBPDLG_FRAMESTAT_MINIMIZED)
// DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList1)
// zbog rada sa Xbase++ XBPDialog() posle rada sa
// programima GuiStdDialog1( prog )
// DCREAD GUI ne funkcionie - ne moe da prekine program
// pa mora da se koristi direktan izlaz sa QUIT
// oDlgGlavni:destroy() -> kad postoji QUIT ovo ne treba
QUIT
RETURN NIL





**************************************************
FUNCTION meni(o,oTree)
**************************************************
/*
 MsgBox(var2char(o)+chr(13)+;
        var2char(o:caption)+chr(13)+;
        var2char(o:cargo[3])+chr(13)+;
        "","Test")
 CLEAR TYPEAHEAD
 RETURN NIL
*/


 *oTree:disable()
 prog := o:caption
 item := o:cargo[3]


 IF item == "11"
    Zaposleni(prog)
 ELSEIF item == "12"
    Porezi(prog)
 ELSEIF item == "13"
    Doprinosi(prog)


 ELSEIF item == "21"
    kalkulacije(prog)
 ELSEIF item == "22"
    Nivelacije(prog)
 ELSEIF item == "23"
    Fakture(prog)


 ELSEIF item == "31"
    Security(prog)
 ELSEIF item == "32"
    Database(prog)
 ELSEIF item == "33"
    Settings(prog)

 ELSEIF item == "34"
    Appearance(prog)
 ELSEIF item == "35"
    Restart(prog)
 ENDIF



 *oTree:enable()
 CLEAR TYPEAHEAD

RETURN NIL




// Xbase++ kod - istovremeni rad sa vie prozora  // XBP_GUIDIALOG.PRG
FUNCTION Zaposleni(prog)   ; GuiStdDialog1( prog ) ; RETURN NIL
FUNCTION Porezi(prog)      ; GuiStdDialog2( prog ) ; RETURN NIL
FUNCTION Doprinosi(prog)   ; GuiStdDialog3( prog ) ; RETURN NIL

// eXpress++ kod - istovremeni rad sa vie prozora // EXP_GUIDIALOG.PRG
FUNCTION kalkulacije(prog) ; dcreadgui1(prog,@getlist1)      ; RETURN NIL
FUNCTION Nivelacije(prog)  ; dcreadgui2(prog,@getlist1)      ; RETURN NIL
FUNCTION Fakture(prog)     ; dcreadgui3(prog,@getlist1)      ; RETURN NIL

FUNCTION security();dcreadgui_1(prog,@getlist1);return nil
FUNCTION database();dcreadgui_1(prog,@getlist1);return nil
FUNCTION Settings();dcreadgui_1(prog,@getlist1);return nil


FUNCTION Appearance()
xpmanifest()
XPRESTART := .T.
kraj()
RETURN NIL

FUNCTION Restart()  // Restart radi odglavljivanja zaglavljenih prozora
MsgBox("RESTART APLIKACIJE","OK")
XPRESTART := .T.
kraj()
RETURN NIL






*******************
FUNCTION HELP1()
*******************


SET CONSOLE OFF
* DELETE FILE txt.txt   // varijanta sa fajlom txt.txt
* TEXT TO FILE txt.txt  // varijanta sa fajlom txt.txt

TEXT INTO txt WRAP //chr(13)+chr(19) // TRIMMED // varijanta sa varijablom txt

PRIRUNIK ZA PROGRAMERE sa gotovim i testiranim programima i Source kodom
programa od kojih se sastoji ova aplikacija. --- Cena za Source je 50 EUR ---

Kako u Alaska Xbase++ programu uz pomo dodatnih eXpress++ DLL biblioteka brzo napraviti
Windows GUI 32 bitnu poslovnu aplikaciju sa Tree interfejsom za glavni meni aplikacije.

Sva uputstva i objanjenja za izradu ove aplikacije nalaze se u source kodu u PRG fajlovima
kao tekst i komentari odreenih tehnika i komandi. Kupovinom source koda i njegovom doradom
i izmenom prema vaim zahtevima, dobijate tehnologiju za razvoj bilo koje vae aplikacije,
(stare clipper aplikaciju ili nove Xbase++ aplikacije, bez gubljenja vremena na uenje svih
tehnika i znanja za izradu takve aplikacije. Ovde je sve uraeno, testirano i dato na tanjiru.

Tree interfejs se postavlja u glavnom prozoru aplikacije (AppWindow) i prua mogunost rada
sa vie istovremeno otvorenih i aktivnih sekundarnih prozora aplikacije, odnosno GUI Dialoga
aplikacije, od kojih svaki GUI dialog predstavlja poseban program. Nadgradnja ovog sistema
je putem uvoenja Thread tehnika tako da svaki od pojedinih GUI dialoga (programa) radi u
svojoj posebnoj niti.
GUI dialozi su uraeni posebno u Alaska Xbase++ funkcijama i posebno u eXpress++ funkcijama
radi prikaza razlike u programiranju u jednoj i u drugoj tehnologiji rada. U aplikaciji su
primenjene tehnike za spreavanje starta druge instance prozora, za restart aplikacije u toku
rada, za postavljanje Windows XP manifesta u toku rada, za postavljanje pozadinske bitmape i
boje i za izgradnju GUI Dialoga sa svim njegovim osobinama i sa drugim objektima na njemu,
tehnika pisanja Helpa u MsgBox dialogu, tehnika izrade panela u GUI dialogu i mnoge druge.

U principu, kod izrade aplikacija u Alaska Xbase++ moe se paralelno koristiti Xbase++ kod i
eXpress++ kod, osim kod Xbase Parts (XbpDialog, XbpPushButton, Xbpbrowse...) gde ne treba
u istom programu koristiti Xbase Parts i eXpress predefinisane Xbase Parts (DCREAD GUI,
DCPUSHBUTTON, DCBROWSE...). U ovoj aplikaciji prva tri GUI dialoga su Xbase Parts
a ostali GUI dialozi su predefinisani eXpress Parts.
Meutim treba to izbegavati, i ne treba meati ove dve tehnike rada, osim ako niste majstor
za Xbase++ i eXpress++ tehnike rada.

Coba 26.05.2011   www.cobasystems.com   cobasystems@gmail.com
BAST Bussines Account Software Techology Open Source Project CSYSTEMS
ENDTEXT
SET CONSOLE ON
* txt := MEMOREAD("txt.txt")  // varijanta sa fajlom txt.txt

* MsgBox(txt,GlavniTitle)
confirmbox(,txt,GlavniTitle,XBPMB_OK)

 HELP2()

RETURN NIL



*******************
FUNCTION HELP2()
*******************


SET CONSOLE OFF
* DELETE FILE txt.txt   // varijanta sa fajlom txt.txt
* TEXT TO FILE txt.txt  // varijanta sa fajlom txt.txt

TEXT INTO txt WRAP //chr(13)+chr(19) // TRIMMED // varijanta sa varijablom txt
 U P U T S T V O
 KAKO DA IZ XBASE++ PROJEKTA www.cobasystems.com/download/18_source.zip
 ( http://www.cobasystems.com/source_code_free/xbaseexpress.htm )
 KOMPAJLUJETE I LINKUJETE SOURCE MATERIJAL I DOBIJETE EXE APLIKACIJU

 1. Instalirajte Alaska Xbase++ 1.7
 2. Instalirajte Alaska XbToolsIII 1.7
 3. Instalirajte eXpress++ 1.7
 4. Kopirajte folder 18_source na C:\ da dobijete C:\18_source
 5. Uite u folder 18_source
 6. startujte TEST.BAT
 7. Dobiete XBAPP1.EXE
 8. Na disku C:\ formirajte folder PROGRAM da dobijete C:\PROGRAM

 9.
    U folder C:\PROGRAM kopirajte sve RunTime DLL
    i druge fajlove iz paketa CSYSTEMS_RUNTIME.EXE

 10.
    Da bi ovaj program XBAPP1.EXE radio,
    morate preuzeti sa interneta RunTime program:
    http://www.cobasystems.com/download1/CSYSTEMS_RUNTIME.EXE
    Startujte zatim preuzeti setup program CSYSTEMS_RUNTIME.EXE
    i instalirajte programe iz njega u eljeni folder, u ovom primeru u

    C:\PROGRAM

    posle toga u isti folder C:\PROGRAM kopirajte program XBAPP1.EXE
    i startujte ga duplim klikom mia na njega.

 Ova demo aplikacija je deo knjige:
 PROGRAMIRANJE U ALASKA XBASE++ I EXPRESS++
 ZA CLIPPER PROGRAMERE
 http://www.cobasystems.com
 COBA Systems 02.07.2011
ENDTEXT
SET CONSOLE ON
* txt := MEMOREAD("txt.txt")  // varijanta sa fajlom txt.txt

confirmbox(,txt,GlavniTitle,XBPMB_OK)

CLEAR TYPEAHEAD
RETURN NIL



